﻿using System;
using System.Runtime.InteropServices;

namespace Xls
{
    public class XlsHelpers
    {
        ////////////////////////////////////////////////////////
        public enum Align_Horz {
                            ALIGN_HORZ_GENERAL  = 0,
                            ALIGN_HORZ_LEFT     = 1,
                            ALIGN_HORZ_CENTER   = 2,
                            ALIGN_HORZ_RIGHT    = 3,
                            ALIGN_HORZ_FILLED   = 4,
                            ALIGN_HORZ_JUSTIFIED= 5
                        };
        public enum Align_Vert {
                            ALIGN_VERT_TOP      = 0,
                            ALIGN_VERT_CENTER   = 1,
                            ALIGN_VERT_BOTTOM   = 2,
                            ALIGN_VERT_JUSTIFIED= 3
                        };
        public enum Line_Styles{
                            LINE_STYLES_NONE    = 0,
                            LINE_STYLES_THIN    = 1,
                            LINE_STYLES_MEDIUM  = 2,
                            LINE_STYLES_THICK   = 5,
                            LINE_STYLES_DOUBLE  = 6
                        };
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#156",
                SetLastError = true, CharSet = CharSet.Ansi,
                ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        void SetRangeText(string worksheetName,
                                    ushort wRow, ushort wCol,
                                    string text,
                                    string fontName,
                                    ushort fontSize,
                                    bool isBold,
                                    bool isItalic,
                                    bool isUnderlined,
                                    Align_Horz alignHorz,
                                    Align_Vert alignVert,
                                    Line_Styles lineStyleLeft,
                                    Line_Styles lineStyleTop,
                                    Line_Styles lineStyleRight,
                                    Line_Styles lineStyleBottom);
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#155",
                SetLastError = true, CharSet = CharSet.Ansi,
                ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        void SetRangeNumber(string worksheetName,
                                    ushort wRow, ushort wCol,
                                    double number,
                                    string fontName,
                                    ushort fontSize,
                                    bool isBold,
                                    bool isItalic,
                                    bool isUnderlined,
                                    Align_Horz alignHorz,
                                    Align_Vert alignVert,
                                    Line_Styles lineStyleLeft,
                                    Line_Styles lineStyleTop,
                                    Line_Styles lineStyleRight,
                                    Line_Styles lineStyleBottom);
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#154",
                SetLastError = true, CharSet = CharSet.Ansi,
                ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        void SetRangeFormula(string worksheetName,
                                    ushort wRow, ushort wCol,
                                    string formula,
                                    string fontName,
                                    ushort fontSize,
                                    bool isBold,
                                    bool isItalic,
                                    bool isUnderlined,
                                    Align_Horz alignHorz,
                                    Align_Vert alignVert,
                                    Line_Styles lineStyleLeft,
                                    Line_Styles lineStyleTop,
                                    Line_Styles lineStyleRight,
                                    Line_Styles lineStyleBottom);
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#135",
                SetLastError = true, CharSet = CharSet.Ansi,
                ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        void SetColWidth(string worksheetName,
                                  ushort wCol,
                                  double width);
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#158",
                SetLastError = true, CharSet = CharSet.Ansi,
                ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        void SetRowHeight(string worksheetName,
                                  ushort wRow,
                                  double height);
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#58",
                SetLastError = true, CharSet = CharSet.Ansi,
                ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        ushort ColStringToColInd(string colAsString);
        ////////////////////////////////////////////////////////
        [DllImport("DirectXLS.dll", EntryPoint = "#128",
            SetLastError = true, CharSet = CharSet.Ansi,
            ExactSpelling = true, CallingConvention = CallingConvention.Cdecl)]
        public static extern
        void Save(string szFilePath);
        ////////////////////////////////////////////////////////
    }
}
