//---------------------------------------------------------------------------
#pragma once
#include "XlsWorkbooks.h"
#include "XlsPtr.h"
#include "XlsObject.h"
//---------------------------------------------------------------------------
namespace Xls
{
//---------------------------------------------------------------------------
class EXPORT_IMPORT_DirectXLS CApplication : public CObject
{
	friend class CWorkbooks;
public:
	// the factory - the first method to call
    static TApplicationPtr		Create();
public:
    void LoadFunctions();
    void QueryLocaleData();
    void QueryMonitorData();

    void Save( const char* szFilePath);

    TWorkbooksPtr Workbooks();
    TWorkbookPtr Workbook( unsigned int index);

    char GetDecimalSeparator()	const;
    char GetThousandsSeparator()const;
    char GetListSeparator()		const;
    char GetColumnSeparator()	const;
    const char* GetGeneralFormatName() const;
private:
    CApplication(void* pimpl);
    ~CApplication();
private:
    CApplication( const CApplication& excel);
	CApplication& operator=( const CApplication& wbs);
};
//---------------------------------------------------------------------------
}
//---------------------------------------------------------------------------
