//---------------------------------------------------------------------------
#pragma once
#include "XlsPtr.h"
#include "XlsBase.h"
//---------------------------------------------------------------------------
namespace Xls
{
//---------------------------------------------------------------------------
class EXPORT_IMPORT_DirectXLS CInterior : public CBase
{
	friend class CWorksheet;
	friend class CObject;
public:
    enum Align_Horz {
                        ALIGN_HORZ_GENERAL  = 0,
                        ALIGN_HORZ_LEFT     = 1,
                        ALIGN_HORZ_CENTER   = 2,
                        ALIGN_HORZ_RIGHT    = 3,
                        ALIGN_HORZ_FILLED   = 4,
                        ALIGN_HORZ_JUSTIFIED= 5
                    };
    enum Align_Vert {
                        ALIGN_VERT_TOP      = 0,
                        ALIGN_VERT_CENTER   = 1,
                        ALIGN_VERT_BOTTOM   = 2,
                        ALIGN_VERT_JUSTIFIED= 3
                    };
    enum Line_Styles{
                        LINE_STYLES_NONE    = 0,
                        LINE_STYLES_THIN    = 1,
                        LINE_STYLES_MEDIUM  = 2,
                        LINE_STYLES_THICK   = 5,
                        LINE_STYLES_DOUBLE  = 6
                    };
public:
    CInterior&	operator= ( const CInterior& rh);
    bool		operator==( const CInterior& rh) const;
    bool		operator!=( const CInterior& rh) const;
public:
        void SetDefault();
            //---------------
		void SetAlignmentHorz( Align_Horz eAlign_Horz);
        void SetAlignmentVert( Align_Vert eAlign_Vert);
        void SetWrapText( bool fToWrap);

		Align_Horz	GetAlignmentHorz() const;
        Align_Vert	GetAlignmentVert() const;
        bool		GetWrapText() const;
            //---------------
		void SetLineLeft   ( Line_Styles eStyle);
        void SetLineRight  ( Line_Styles eStyle);
        void SetLineTop    ( Line_Styles eStyle);
        void SetLineBottom ( Line_Styles eStyle);
        void SetLineArround( Line_Styles eStyle);

		Line_Styles GetLineLeft() const;
        Line_Styles GetLineRight() const;
        Line_Styles GetLineTop() const;
        Line_Styles GetLineBottom() const;
            //---------------
        void SetBackgroundColor( COLORREF refColor);
		void SetBackgroundColor( BYTE bRed, BYTE bGreen, BYTE bBlue);
            //---------------
private:
    CInterior(void* pimpl);
    ~CInterior();
private:
    CInterior( const CInterior&);
};
//---------------------------------------------------------------------------
}
//---------------------------------------------------------------------------

