//---------------------------------------------------------------------------
#pragma once
#include "XlsPtr.h"
#include "XlsInterior.h"
#include "XlsFormat.h"
#include "XlsFont.h"
#include "XlsRange.h"
#include "XlsObject.h"
//---------------------------------------------------------------------------
namespace Xls
{
//---------------------------------------------------------------------------
class EXPORT_IMPORT_DirectXLS CWorksheet : public CObject
{
	friend class CRange;
	friend class CWorksheets;
	friend class CWorkbook;
public:
    void		SetName( const char* sName);
	const char* GetName() const;

    void SetSelected();
    bool IsSelected();

    virtual TFontPtr     Font();
    virtual TFormatPtr   Format();
    virtual TInteriorPtr Interior();

    TRangePtr Range( unsigned short wRow, unsigned short wCol);
    TRangePtr Range( unsigned short wRowFirst, unsigned short wColFirst, unsigned short wRowLast, unsigned short wColLast);
    TRangePtr Range( const char* szAddress);

    TRangePtr Cells();
    TRangePtr Row( unsigned short wRow);
    TRangePtr Col( unsigned short wCol);

    unsigned short GetRight();
    unsigned short GetRightMax();

    TWorksheetsPtr Parent() const;
private:
    CWorksheet(void* pimpl);
    ~CWorksheet();
private:
    CWorksheet( const CWorksheet& ws);
    CWorksheet& operator=( const CWorksheet& ws);
};
//---------------------------------------------------------------------------
}
//---------------------------------------------------------------------------
