﻿using System;

namespace DemoCSharp
{
    public class DemoHelpers
    {
        //////////////////////////////////////////////////////////////
        public static void SaveCommon(string filePath)
        {
        	DateTime time = DateTime.Now;
	        //
            string worksheetName = "Formatted data";
            string colStringText = "B";
	        string colStringNumbers	= "C";
	        ushort colIndText		= XlsHelpers.ColStringToColInd( colStringText);
	        ushort colIndNumbers	= XlsHelpers.ColStringToColInd( colStringNumbers);

	        ushort rowIndHeader = 2;
	        ushort rowIndLast	= 10005;
	        //
            XlsHelpers.SetRowHeight(worksheetName, rowIndHeader, 20);
            XlsHelpers.SetColWidth(worksheetName, colIndText, 23);
            XlsHelpers.SetColWidth(worksheetName, colIndNumbers, 14);
            //
            XlsHelpers.SetRangeText(
                worksheetName, rowIndHeader, colIndText, "Text",
                "Arial", 12,
                true, false, false,
                XlsHelpers.Align_Horz.ALIGN_HORZ_CENTER,
                XlsHelpers.Align_Vert.ALIGN_VERT_CENTER,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN,
                XlsHelpers.Line_Styles.LINE_STYLES_NONE,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN);
            //
            XlsHelpers.SetRangeText(
                worksheetName, rowIndHeader, colIndNumbers, "Number",
		        "Arial", 12,
		        true, false, false,
                XlsHelpers.Align_Horz.ALIGN_HORZ_CENTER,
                XlsHelpers.Align_Vert.ALIGN_VERT_CENTER,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN,
                XlsHelpers.Line_Styles.LINE_STYLES_THIN);
            //
            // huge number of cells
            ushort i = (ushort)(rowIndHeader + 1);
            for (; i <= rowIndLast; i++)
            {
	            XlsHelpers.SetRangeText(
                    worksheetName, i, colIndText, "See formula at the bottom",
		            "Verdana", 8,
		            false, false, false,
		            XlsHelpers.Align_Horz.ALIGN_HORZ_GENERAL, 
		            XlsHelpers.Align_Vert.ALIGN_VERT_BOTTOM,
		            XlsHelpers.Line_Styles.LINE_STYLES_NONE, 
		            XlsHelpers.Line_Styles.LINE_STYLES_NONE, 
		            XlsHelpers.Line_Styles.LINE_STYLES_NONE, 
		            XlsHelpers.Line_Styles.LINE_STYLES_NONE);
                //
                XlsHelpers.SetRangeNumber(
                    worksheetName, i, colIndNumbers, i,
                    "Verdana", 8,
                    false, false, false,
                    XlsHelpers.Align_Horz.ALIGN_HORZ_GENERAL,
                    XlsHelpers.Align_Vert.ALIGN_VERT_BOTTOM,
                    XlsHelpers.Line_Styles.LINE_STYLES_NONE,
                    XlsHelpers.Line_Styles.LINE_STYLES_NONE,
                    XlsHelpers.Line_Styles.LINE_STYLES_NONE,
                    XlsHelpers.Line_Styles.LINE_STYLES_NONE);
            }
	        // total
	        XlsHelpers.SetRangeText(
		        worksheetName, i, colIndText, "Total",
		        "Verdana", 8,
		        true, false, false,
		        XlsHelpers.Align_Horz.ALIGN_HORZ_GENERAL, 
		        XlsHelpers.Align_Vert.ALIGN_VERT_BOTTOM,
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN, 
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN, 
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN, 
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN);
	        //
	        string formula = "=SUM(";
            formula += colStringNumbers + (rowIndHeader + 1)
                    + ':' + colStringNumbers + rowIndLast
			        + ")";

	        XlsHelpers.SetRangeFormula(
		        worksheetName, i, colIndNumbers, formula,
		        "Verdana", 8,
		        true, false, false, 
		        XlsHelpers.Align_Horz.ALIGN_HORZ_GENERAL, 
		        XlsHelpers.Align_Vert.ALIGN_VERT_BOTTOM,
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN, 
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN, 
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN, 
		        XlsHelpers.Line_Styles.LINE_STYLES_THIN);
            //=================================
	        TimeSpan timeSpan = DateTime.Now - time;
            int timeSec = timeSpan.Seconds + 1;

            string pchTime =
                "It took " + timeSec.ToString() + ".";
            //
            string milli = timeSpan.Milliseconds.ToString();
            if (milli.Length > 3)
                milli = milli.Substring(0, 3);
            pchTime += 
                milli + 
                " seconds to create and write down this file";

	        XlsHelpers.SetRangeText(
		        worksheetName, 1, 4, pchTime,
		        "Verdana", 20,
		        true, false, false,
		        XlsHelpers.Align_Horz.ALIGN_HORZ_GENERAL, 
		        XlsHelpers.Align_Vert.ALIGN_VERT_BOTTOM,
		        XlsHelpers.Line_Styles.LINE_STYLES_NONE, 
		        XlsHelpers.Line_Styles.LINE_STYLES_NONE, 
		        XlsHelpers.Line_Styles.LINE_STYLES_NONE, 
		        XlsHelpers.Line_Styles.LINE_STYLES_NONE);
            //
            XlsHelpers.Save(filePath);
        }
    }
}