//---------------------------------------------------------------------------
#include "stdafx.h"
#include <stdio.h>
#include <sstream>
#include <vector>
#include <map>
//
#include "DemoLowLevel.h"
//---------------------------------------------------------------------------
CDemoLowLevel::CDemoLowLevel()
{
}
//---------------------------------------------------------------------------
CDemoLowLevel::~CDemoLowLevel()
{
}
//---------------------------------------------------------------------------
bool CDemoLowLevel::SaveCommon( const std::string& strFilePath,
							bool fIsWithFormulas,
							WTL::CProgressBarCtrl*	progress)
{
try
{
	TApplicationPtr excel = CreateApplication();
	unsigned int timeMilli = ::GetTickCount();

	excel->LoadFunctions();
    excel->QueryLocaleData();
    excel->QueryMonitorData();

	TWorkbooksPtr wbs = excel->Workbooks();
    TWorkbookPtr wb  = wbs->Add("");

	{
        TFontPtr ft = wb->Font();
        ft->SetName("MS Sans Serif");
        ft->SetSize(12);
    }
    TWorksheetsPtr wss = wb->Worksheets();

	TRangePtr rStart, rStartMost2;
        //============================================
    TWorksheetPtr ws2 = wss->Add("Formatted data");
    ws2->Font()->SetName("Verdana");
    ws2->Font()->SetSize(8);

	std::string sF1 = std::string( excel->GetGeneralFormatName()) + ';' + '-' + excel->GetGeneralFormatName() + ';';
    ws2->Format()->SetFormatString(sF1.c_str());
    
	rStart = ws2->Range( 1, 1);
    rStartMost2 = rStart;

    TRangePtr r = rStart->Range(21,1)->GetEntireRows();
    r->Font()->SetSize(20);
	//
    r = rStart->Range(3,2)->GetEntireCols();
    r->SetColWidth(6);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_RIGHT);
	//
    r = ws2->Range(3, 2, 4, 2);
    r->SetMerged( true);
    r->SetColWidth(5);
	r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_CENTER);
    r->SetText( "N");
	//
    r = rStart->Range(3,3)->GetEntireCols();
    r->Interior()->SetWrapText( true);
	//
    r = ws2->Range(3, 3, 4, 3);
    r->SetMerged( true);
    r->SetColWidth(14);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_CENTER);
    r->Interior()->SetWrapText( true);
    r->SetText( "Formatted data");
	//
    r = ws2->Range(3, 4, 3, 8);
    r->SetMerged( true);
    r->Interior()->SetLineArround( CInterior::LINE_STYLES_THIN);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->SetText( "Examples");
	//
    for( int i=0; i < 5; i++)
    {
        r = ws2->Range(4, i + 4, 4, i + 4);
        if( i == 1  ||  i == 2)
            r->SetColWidth(12);
        else
            r->SetColWidth(7);
        if( i == 0)
        {
            r->SetRowHeight(13);
        }
        r->Interior()->SetLineArround( CInterior::LINE_STYLES_THIN);
        r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
        r->SetNumber( 1 + i);
    }
	//
    r = ws2->Range(3, 2, 4, 8);
    r->Interior()->SetDefault();
    r->Interior()->SetLineArround( CInterior::LINE_STYLES_DOUBLE);
        //== record 1 ==
    r = ws2->Range(5, 2);
    r->SetFormula("=TEXT(1,\"#\")&\".\"");
    r = ws2->Range(5, 3);
    r->SetText( "Alignment horizontal");
    r = ws2->Range(5, 4);
    r->SetText( "Left");
    r = ws2->Range(5, 5);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->SetText( "Center");
    r = ws2->Range(5, 6);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_RIGHT);
    r->SetText( "Right");
        //== record 2 ==
    r = ws2->Range(6, 2);
    r->SetFormula("=TEXT(2,\"#\")&\".\"");
    r = ws2->Range(6, 3);
    r->SetText( "Alignment vertical");
    r = ws2->Range(6, 4);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_BOTTOM);
    r->SetText( "Bottom");
    r = ws2->Range(6, 5);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_CENTER);
    r->SetText( "Center");
    r = ws2->Range(6, 6);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_TOP);
    r->SetText( "Top");
        //== record 3 ==
    r = ws2->Range(7, 2);
    r->SetFormula("=TEXT(3,\"#\")&\".\"");
    r = ws2->Range(7, 3);
    r->SetText( "Cells Merging");
    r = ws2->Range(7, 4, 8, 4);
    r->SetMerged( true);
    r->Interior()->SetWrapText( true);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_CENTER);
    r->SetText( "Vertical");
    r = ws2->Range(7, 5, 7, 6);
    r->SetMerged( true);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_CENTER);
    r->SetText( "Horizontal");
    r = ws2->Range(7, 7, 8, 8);
    r->SetMerged( true);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_CENTER);
    r->Interior()->SetAlignmentVert( CInterior::ALIGN_VERT_CENTER);
    r->SetText( "Area");
        //== record 4 ==
        r = ws2->Range(9, 2);
    r->SetFormula("=TEXT(4,\"#\")&\".\"");
    r = ws2->Range(9, 3);
    r->SetText( "Font");
    r = ws2->Range(9, 4);
    r->Interior()->SetWrapText( true);
    r->Font()->SetName("MS Sans Serif");
    r->SetText( r->Font()->GetName());
    r = ws2->Range(9, 5);
    r->Interior()->SetWrapText( true);
    r->Font()->SetName("Courier New");
    r->SetText( r->Font()->GetName());
    r = ws2->Range(9, 6);
    r->Font()->SetName("Arial");
    r->SetText( r->Font()->GetName());
    r = ws2->Range(9, 7);
    r->Interior()->SetWrapText( true);
    r->Font()->SetName("Times New Roman");
    r->SetText( r->Font()->GetName());
        //== record 5 ==
    r = ws2->Range(10, 2);
    r->SetFormula("=TEXT(5,\"#\")&\".\"");
    r = ws2->Range(10, 3);
    r->SetText( "Font Weight");
    r = ws2->Range(10, 4);
    r->SetText( "Normal");
    r = ws2->Range(10, 5);
    r->Font()->SetBold(true);
    r->SetText( "Bold");
        //== record 6 ==
    r = ws2->Range(11, 2);
    r->SetFormula("=TEXT(6,\"#\")&\".\"");
    r = ws2->Range(11, 3);
    r->SetText( "Italic");
    r = ws2->Range(11, 4);
    r->SetText( "Normal");
    r = ws2->Range(11, 5);
    r->Font()->SetItalic(true);
    r->SetText( "Italic");
    r = ws2->Range(11, 6);
    r->Font()->SetBold(true);
    r->Font()->SetItalic(true);
    r->Interior()->SetWrapText( true);
    r->SetText( "Bold and Italic");
        //== record 7 ==
    r = ws2->Range(12, 2);
    r->SetFormula("=TEXT(7,\"#\")&\".\"");
    r = ws2->Range(12, 3);
    r->SetText( "Underline");
    r = ws2->Range(12, 4);
    r->SetText( "Normal");
    r = ws2->Range(12, 5);
    r->Font()->SetUnderline(true);
    r->SetText( "Underline");
    r = ws2->Range(12, 6);
    r->Font()->SetBold(true);
    r->Font()->SetItalic(true);
    r->Font()->SetUnderline(true);
    r->Interior()->SetWrapText( true);
    r->SetText( "Bold, Italic and Underline");
        //== record 8 ==
    r = ws2->Range(13, 2);
    r->SetFormula("=TEXT(8,\"#\")&\".\"");
    r = ws2->Range(13, 3);
    r->SetText( "Font Size");
    r = ws2->Range(13, 4);
    r->Font()->SetSize(10);
    r->SetNumber( 10);
    r = ws2->Range(13, 5);
    r->Font()->SetSize(16);
    r->SetNumber( 16);
    r = ws2->Range(13, 6);
    r->Font()->SetSize(20);
    r->SetNumber( 20);
        //== record 9 ==
    r = ws2->Range(14, 2);
    r->Interior()->SetAlignmentHorz( CInterior::ALIGN_HORZ_RIGHT);
    r->SetFormula("=TEXT(9,\"#\")&\".\"");
    r = ws2->Range(14, 3);
    r->SetText( "Font color");
    r = ws2->Range(14, 4);
    r->Interior()->SetBackgroundColor( RGB(64,64,64));
    r = ws2->Range(14, 5);
    r->Interior()->SetBackgroundColor( RGB(96,96,96));
    r = ws2->Range(14, 6);
    r->Interior()->SetBackgroundColor( RGB(128,128,128));
    r = ws2->Range(14, 7);
    r->Interior()->SetBackgroundColor( RGB(255,255,0));
    r = ws2->Range(14, 8);
    r->Interior()->SetBackgroundColor( RGB(255,0,0));
        //== record 10 ==
    r = ws2->Range(15, 2);
    r->SetFormula("=TEXT(10,\"#\")&\".\"");
    r = ws2->Range(15, 3);
    r->SetText( "Cell Format");
    r = ws2->Range(15, 4);
    std::string s2 = excel->GetGeneralFormatName();
    r->Format()->SetFormatString(s2.c_str());
    r->SetNumber( 23.456789);
    r = ws2->Range(15, 5);
        s2 = "# ##0;-# ##0;";
    r->Format()->SetFormatString(s2.c_str());
    r->SetNumber( 23.456789);
    r = ws2->Range(15, 6);
        s2 = "# ##0,00;-# ##0,00;";
    r->Format()->SetFormatString(s2.c_str());
    r->SetNumber( 23.456789);
        //== record 11 ==
    r = ws2->Range(16, 2);
    r->SetFormula("=TEXT(11,\"#\")&\".\"");
    r = ws2->Range(16, 3);
    r->SetText( "Border");
    r = ws2->Range(16, 4);
    r->Interior()->SetLineArround( CInterior::LINE_STYLES_THIN);
    r->SetText( "Thin");
    r = ws2->Range(16, 5);
    r->Interior()->SetLineArround( CInterior::LINE_STYLES_MEDIUM);
    r->SetText( "Medium");
    r = ws2->Range(16, 6);
    r->Interior()->SetLineArround( CInterior::LINE_STYLES_THICK);
    r->SetText( "Thick");
    r = ws2->Range(16, 7);
    r->Interior()->SetLineArround( CInterior::LINE_STYLES_DOUBLE);
    r->SetText( "Double");
        //== record 12 ==
    r = ws2->Range(17, 2);
    r->SetFormula("=TEXT(12,\"#\")&\".\"");
    r = ws2->Range(17, 3);
    r->SetText( "This page has font Verdana 8, and the whole workbook - MS Sans Serif 12. Please insert a new page to make sure that it will have MS Sans Serif 12.");
        //== record 13 ==
    r = ws2->Range(18, 2);
    r->SetFormula("=TEXT(13,\"#\")&\".\"");
    r = ws2->Range(18, 3);
    r->SetText( "All cells in column \"C\" have property \"Wrap by words\" - \"On\". It was done in the only one operation");
        //== record 14 ==
    r = ws2->Range(19, 2);
    r->SetFormula("=TEXT(14,\"#\")&\".\"");
    r = ws2->Range(19, 3);
    r->SetText( "Width of columns \"D\",\"E\",\"F\",\"G\",\"H\" is set by this demo progarm to 7,12,12,7 and 7 correspondingly");
        //== record 15 ==
    r = ws2->Range(20, 2);
    r->SetFormula("=TEXT(15,\"#\")&\".\"");
    r = ws2->Range(20, 3);
    r->SetText( "Height of the row 4 is set by this demo progarm to 13");
        //== record 16 ==
    r = ws2->Range(21, 2);
    r->SetFormula("=TEXT(16,\"#\")&\".\"");
    r = ws2->Range(21, 3, 21, 8);
    r->SetMerged( true);
    r->SetText( "Font size in this row is 20");
        //== record 17 ==
    r = ws2->Range(22, 2);
    r->SetFormula("=TEXT(17,\"#\")&\".\"");
    r = ws2->Range(22, 3, 22, 8);
    r->SetMerged( true);
	std::string text = "Address of this cell is ";
	std::string address;
	unsigned int buffSize = 0;
	if (!r->GetAddress(false, 0, buffSize))
	{
		address.resize(buffSize);
		if (!r->GetAddress(false, (char*)address.c_str(), buffSize))
			throw std::runtime_error("Failed: ExcelRange::GetAddress");
	}
	text += address;
    r->SetText( text.c_str());
        //== record last ==
    r = ws2->Range(22, 2, 22, 8);
    r->Interior()->SetLineBottom( CInterior::LINE_STYLES_THICK);

	if( progress)
		progress->SetPos(1);

		// huge number of cells
    for( int i=3; i <= 10005; i++)
    {
        r = ws2->Range(i, 10);
        r->SetNumber( i);
        r = ws2->Range(i, 11);
        r->SetText( "Huge table");
    }
	if( progress)
		progress->SetPos(2);

        //=================================
	if( fIsWithFormulas)
	{
		AddFormulas(wss, progress);
	}
        //=================================
	timeMilli = ::GetTickCount() - timeMilli;
    double timeSec = ((double)timeMilli / 1000.0) + 1.0;

	std::ostringstream timeAsText;
	timeAsText << "It took ";
	timeAsText.precision(4);
	timeAsText << timeSec << " seconds to create and write down this file";

	r = rStartMost2->Range(1, 4);
    r->Font()->SetSize(20);
    r->Font()->SetBold(true);
    ws2->Format()->SetFormatString( excel->GetGeneralFormatName());
	r->SetText( timeAsText.str().c_str());

	if( progress)
		progress->SetPos(13);

	excel->Save( strFilePath.c_str());

	if( progress)
		progress->SetPos(14);
	return true;
}
catch( std::exception& e)
{
	::MessageBox( NULL, e.what(), "", MB_OK);
}
    return false;
}
//---------------------------------------------------------------------------
void CDemoLowLevel::AddFormulas(TWorksheetsPtr wss, WTL::CProgressBarCtrl* progress)
{
	TWorksheetPtr ws = wss->Add("");
	ws->SetName("Embedded Excel functions");
	ws->Font()->SetName("Verdana");
	ws->Font()->SetSize(7);

	EFuncGroup peFuncGroup[] = {FG_LOG, 
								FG_ARIPH, FG_TEXT, FG_DATETIME, FG_FIN, FG_STAT,
								FG_INF, FG_BD, FG_SSYLKA, FG_INJENER,
								FG_ARRAY,
							   (EFuncGroup)-1};
	TRangePtr rStart = ws->Range( 1, 1);
	TRangePtr rStartMost = rStart;
	rStart = rStart->Range( 3, 1);
	TFontPtr font = rStart->GetEntireRows()->Font(); 
	font->SetBold(true);
	font->SetName("MS Sans Serif");
	font->SetSize(10);
	//
	rStart->Range(1,1)->SetText( "Formula");
	rStart->Range(1,2)->SetText( "Function name in this formula");
	rStart->Range(1,3)->SetText( "Input data");
	rStart = rStart->Range( 3, 1);
	rStart->Range(1,2)->SetColWidth(54);

	std::string sFormula, sText, sNaim;
	int nNumOfGroups;
	for( nNumOfGroups = 0; peFuncGroup[nNumOfGroups] >= 0; nNumOfGroups++)
	{
	}
	int nRow = 0;
	for( int j=0; j < nNumOfGroups; j++, nRow += 3)
	{
		if( progress)
			progress->SetPos(2 + j);

		if( (3+nRow) % 2 != 0)
		{
			nRow += 1;
		}
		EFuncGroup eFuncGroup = peFuncGroup[j];
		int nRow_GroupStart = nRow;
		switch( eFuncGroup)
		{
		case FG_BD:
			{
				char* pchCap0[] = {"Tree","Height","Age","Fruits","Income","Height"};
				for(int i=0; i < 6; i++)
				{
					TRangePtr r = rStart->Range( 0 + 3+nRow_GroupStart, i + 3);
					r->Font()->SetBold(true);
					r->SetText( pchCap0[i]);
				}
				char* pchCap1[] = {"Apple",">3","","","","<5"};
				for(int i=0; i < 6; i++)
				{
					TRangePtr r = rStart->Range( 1 + 3+nRow_GroupStart, i + 3);
					r->SetText( pchCap1[i]);
				}
				char* pchCap2[] = {"Pear","","","","",""};
				for(int i=0; i < 6; i++)
				{
					TRangePtr r = rStart->Range( 2 + 3+nRow_GroupStart, i + 3);
					r->SetText( pchCap2[i]);
				}
				char* pchCap3[] = {"","","","","",""};
				for(int i=0; i < 6; i++)
				{
					TRangePtr r = rStart->Range( 3 + 3+nRow_GroupStart, i + 3);
					r->SetText( pchCap3[i]);
				}
				char* pchCap4[] = {"Tree","Height","Age","Fruits","Income"};
				for(int i=0; i < 5; i++)
				{
					TRangePtr r = rStart->Range( 4 + 3+nRow_GroupStart, i + 3);
					r->Font()->SetBold(true);
					r->SetText( pchCap4[i]);
				}
				char* pchCap5[] = {"Apple","Pear","Cherry","Apple","Pear","Apple"};
				for(int i=0; i < 6; i++)
				{
					TRangePtr r = rStart->Range( i + 5 + 3+nRow_GroupStart, 3);
					r->SetText( pchCap5[i]);
				}
				int pnNum5[] = {6, 20, 14, 105000};
				for(int i=0; i < 4; i++)
				{
					TRangePtr r = rStart->Range( 5 + 3+nRow_GroupStart, i + 4);
					r->SetNumber( pnNum5[i]);
				}
				int pnNum6[] = {4, 12, 10, 96000};
				for(int i=0; i < 4; i++)
				{
					TRangePtr r = rStart->Range( 6 + 3+nRow_GroupStart, i + 4);
					r->SetNumber( pnNum6[i]);
				}
				int pnNum7[] = {4, 14, 9, 105000};
				for(int i=0; i < 4; i++)
				{
					TRangePtr r = rStart->Range( 7 + 3+nRow_GroupStart, i + 4);
					r->SetNumber( pnNum7[i]);
				}
				int pnNum8[] = {5, 15, 10, 75000};
				for(int i=0; i < 4; i++)
				{
					TRangePtr r = rStart->Range( 8 + 3+nRow_GroupStart, i + 4);
					r->SetNumber( pnNum8[i]);
				}
				int pnNum9[] = {3, 8, 8, 76000};
				for(int i=0; i < 4; i++)
				{
					TRangePtr r = rStart->Range( 9 + 3+nRow_GroupStart, i + 4);
					r->SetNumber( pnNum9[i]);
				}
				int pnNum10[] = {3, 9, 6, 45000};
				for(int i=0; i < 4; i++)
				{
					TRangePtr r = rStart->Range( 10 + 3+nRow_GroupStart, i + 4);
					r->SetNumber( pnNum10[i]);
				}
			}
			break;
		}
		for( int i=0; true; i++, nRow++)
		{
			switch( eFuncGroup)
			{
			case FG_ARIPH:
				sNaim = "Math and trigonometry functions";
				sFormula = GetFormula_Ariph(i);
				sText    = GetFormulaText_Ariph(i);
				if( !sFormula.empty())
				{
					if( sText == "ACOSH")
					{
						rStart->Range(3+nRow,3)->SetNumber(4);
						rStart->Range(3+nRow,4)->SetNumber(4);
					}
					else if( sText == "ATANH")
					{
						rStart->Range(3+nRow,3)->SetNumber(0.6);
						rStart->Range(3+nRow,4)->SetNumber(0);
					}
					else if( sText == "COMBIN")
					{
						rStart->Range(3+nRow,3)->SetNumber(5);
						rStart->Range(3+nRow,4)->SetNumber(2);
					}
					else if( sText == "RANDBETWEEN")
					{
						rStart->Range(3+nRow,3)->SetNumber(1);
						rStart->Range(3+nRow,4)->SetNumber(10);
					}
					else
					{
						rStart->Range(3+nRow,3)->SetNumber(1);
						rStart->Range(3+nRow,4)->SetNumber(2);
					}
				}
				break;
			case FG_LOG:
				sNaim = "Logical functions";
				sFormula = GetFormula_Log(i);
				sText    = GetFormulaText_Log(i);
				if( (3+nRow) % 2 == 0  &&  !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetFormula( "=TRUE()");
					rStart->Range(4+nRow,3)->SetFormula( "=FALSE()");
					rStart->Range(3+nRow,4)->SetFormula( "=FALSE()");
					rStart->Range(4+nRow,4)->SetFormula( "=TRUE()");
					rStart->Range(3+nRow,5)->SetNumber(227);
					rStart->Range(4+nRow,5)->SetNumber(227);
				}
				break;
			case FG_TEXT:
				sNaim = "Text and data functions";
				sFormula = GetFormula_Text(i);
				sText    = GetFormulaText_Text(i);
				if( !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetText("Combined");
					rStart->Range(3+nRow,4)->SetText("value");
				}
				break;
			case FG_DATETIME:
				sNaim = "Date and time functions";
				sFormula = GetFormula_DateTime(i);
				sText    = GetFormulaText_DateTime(i);
				if( (3+nRow) % 2 == 0  &&  !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetNumber(22);
					rStart->Range(4+nRow,3)->SetNumber(24);
					rStart->Range(3+nRow,4)->SetNumber(23);
					rStart->Range(4+nRow,4)->SetNumber(25);
				}
				break;
			case FG_FIN:
				sNaim = "Financial functions";
				sFormula = GetFormula_Fin(i);
				sText    = GetFormulaText_Fin(i);
				if( (3+nRow) % 2 == 0  &&  !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetNumber(-4000);
					rStart->Range(4+nRow,3)->SetNumber(2000);
					rStart->Range(3+nRow,4)->SetNumber(3000);
					rStart->Range(4+nRow,4)->SetNumber(1000);
				}
				break;
			case FG_STAT:
				sNaim = "Statistical functions";
				sFormula = GetFormula_Stat(i);
				sText    = GetFormulaText_Stat(i);
				if( (3+nRow) % 2 == 0  &&  !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetNumber(1);
					rStart->Range(4+nRow,3)->SetNumber(2);
					rStart->Range(3+nRow,4)->SetNumber(3);
					rStart->Range(4+nRow,4)->SetNumber(4);
					rStart->Range(3+nRow,5)->SetNumber(5);
					rStart->Range(4+nRow,5)->SetNumber(6);
					rStart->Range(3+nRow,6)->SetNumber(7);
					rStart->Range(4+nRow,6)->SetNumber(8);
					rStart->Range(3+nRow,7)->SetNumber(9);
					rStart->Range(4+nRow,7)->SetNumber(10);
				}
				break;
			case FG_INF:
				sNaim = "Information functions";
				sFormula = GetFormula_Inf(i);
				sText    = GetFormulaText_Inf(i);
				break;
			case FG_BD:
				sNaim = "Database and list management functions";
				sFormula = GetFormula_BD(i);
				sText    = GetFormulaText_BD(i);
				break;
			case FG_SSYLKA:
				sNaim = "Lookup and reference functions";
				sFormula = GetFormula_Ssylka(i);
				sText    = GetFormulaText_Ssylka(i);
				if( (3+nRow) % 2 == 0  &&  !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetNumber(1);
					rStart->Range(4+nRow,3)->SetNumber(2);
					rStart->Range(3+nRow,4)->SetNumber(3);
					rStart->Range(4+nRow,4)->SetNumber(4);
					rStart->Range(3+nRow,5)->SetNumber(5);
					rStart->Range(4+nRow,5)->SetNumber(6);
					rStart->Range(3+nRow,6)->SetNumber(7);
					rStart->Range(4+nRow,6)->SetNumber(8);
					rStart->Range(3+nRow,7)->SetNumber(9);
					rStart->Range(4+nRow,7)->SetNumber(10);
				}
				break;
			case FG_INJENER:
				sNaim = "Engineering  funtions";
				sFormula = GetFormula_Injener(i);
				sText    = GetFormulaText_Injener(i);
				if( (3+nRow) % 2 == 0  &&  !sFormula.empty())
				{
					rStart->Range(3+nRow,3)->SetNumber(1);
					rStart->Range(4+nRow,3)->SetNumber(1);
					rStart->Range(3+nRow,4)->SetNumber(2);
					rStart->Range(4+nRow,4)->SetNumber(2);
					rStart->Range(3+nRow,5)->SetNumber(3);
					rStart->Range(4+nRow,5)->SetNumber(3);
				}
				break;
			case FG_ARRAY:
				sNaim = "Array functions";
				sFormula = GetFormula_Array(i);
				sText    = GetFormulaText_Array(i);
				if( !sFormula.empty())
				{
					rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),3)->SetNumber(1);
					rStart->Range(4 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),3)->SetNumber(2);
					rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),4)->SetNumber(3);
					rStart->Range(4 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),4)->SetNumber(4);
					rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),5)->SetNumber(5);
					rStart->Range(4 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),5)->SetNumber(6);
					rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),6)->SetNumber(7);
					rStart->Range(4 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),6)->SetNumber(8);
					rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),7)->SetNumber(9);
					rStart->Range(4 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1),7)->SetNumber(10);
				}
				break;
			default:
				throw( std::runtime_error("Unsupported group in CDemoLowLevel::SaveCommon"));
			}
			if( i == 0)
			{
				TRangePtr r = rStart->Range(1 + nRow, 2);
				r->Font()->SetName("Times New Roman");
				r->Font()->SetBold(true);
				r->Font()->SetSize(12);
				r->SetText( sNaim.c_str());
			}
			if( sFormula.empty())
			{
				break;
			}
			{
				std::string sDecimalSeparator(".");
				std::string sThousandsSeparator(",");
				std::string sListSeparator(";");
				char pchBuff[2001];
				if( ::GetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_SDECIMAL, pchBuff, 2000) > 0) sDecimalSeparator = pchBuff;
				if( ::GetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_STHOUSAND, pchBuff, 2000) > 0) sThousandsSeparator = pchBuff;
				if( ::GetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_SLIST, pchBuff, 2000) > 0) sListSeparator = pchBuff;
				if( sDecimalSeparator.size() > 0)
				{
					sFormula = Replace( sFormula, ',',  sDecimalSeparator.at(0));
				}
				if( sListSeparator.size() > 0)
				{
					sFormula = Replace( sFormula, ';',  sListSeparator.at(0));
				}
			}
			switch( eFuncGroup)
			{
			case FG_ARRAY:
				rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1), 1)->Expand( 2, 1)->SetFormulaArray( sFormula.c_str());
				rStart->Range(3 + nRow_GroupStart + ((nRow - nRow_GroupStart) << 1), 2)->Expand( 2, 1)->SetText( sText.c_str());
				break;
			default:
				rStart->Range(3+nRow,1)->SetFormula( sFormula.c_str());
				rStart->Range(3+nRow,2)->SetText( sText.c_str());
			}
		}
	}
}
//---------------------------------------------------------------------------
// Math and trigonometry functions
    char* g_ppchFormulasAriph[] =
    {
"=ABS(RC[2])                             ",
"=ACOS(RC[2])                            ",
"=ACOSH(RC[2])                           ",
"=ASIN(RC[2])                                  ",
"=ASINH(RC[2])                                 ",
"=ATAN(RC[2])                                    ",
"=ATAN2(RC[2]; RC[3])                                ",
"=ATANH(RC[2])                                 ",
"=CEILING(RC[2]; RC[3])                           ",
"=COMBIN(RC[2]; RC[3])                             ",
"=COS(RC[2])                                 ",
"=COSH(RC[2])                                    ",
"=COUNTIF(R[0]C[2]:R[1]C[2];\"2\")                   ",
"=DEGREES(RC[2])                                 ",
"=EVEN(RC[2])                                  ",
"=EXP(RC[2])                                     ",
"=FACT(RC[2])                                 ",
//"=FACTDOUBLE(RC[2])                                 ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=FLOOR(RC[2]; RC[3])                            ",
//"=GCD(RC[2]; RC[3])                                  ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=INT(RC[2])                                 ",
//"=LCM(RC[2]; RC[3])                                  ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=LN(RC[2])                                     ",
"=LOG(RC[2]; RC[3])                                  ",
"=LOG10(RC[2])                                  ",
"=MOD(RC[2]; RC[3])                                ",
//"=MROUND(RC[2]; RC[3])                             ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
//"=MULTINOMIAL(R[0]C[2]:R[1]C[3])                         ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=ODD(RC[2])                                 ",
"=PI()                                       ",
"=POWER(RC[2];RC[3])                               ",
"=PRODUCT(R[0]C[2]:R[1]C[3]; 2)                         ",
//"=QUOTIENT(RC[2]; RC[3])                              ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=RADIANS(RC[2])                               ",
"=RAND()                                    ",
//"=RANDBETWEEN(RC[2];RC[3])                             ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=ROMAN(RC[2];RC[3])                             ",
"=ROUND(RC[2]; RC[3])                            ",
"=ROUNDDOWN(RC[2]; RC[3])                         ",
"=ROUNDUP(RC[2];RC[3])                         ",
"=SIGN(RC[2])                                   ",
"=SIN(RC[2])                                     ",
"=SINH(RC[2])                                    ",
"=SQRT(RC[2])                                 ",
//"=SQRTPI(RC[2])                                ",// depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=SUBTOTAL(1;R[0]C[3]:R[1]C[3])               ",
"=SUM(R[0]C[2]:R[1]C[3]; 15)                            ",
"=SUMIF(R[0]C[2]:R[1]C[2];\">160000\";R[0]C[3]:R[1]C[3])          ",
"=SUMPRODUCT(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])                        ", 
"=SUMSQ(R[0]C[2]:R[1]C[3])                            ",
"=SUMXMY2(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])                ",
"=SUMX2PY2(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])                ",
"=SUMX2MY2(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])                ",
"=TAN(RC[2])                                 ",
"=TANH(RC[2])                                  ",
"=TRUNC(RC[2];RC[3])                                ",
NULL
};
//---------------------------------------------------------------------------
// Logical functions
    char* g_ppchFormulasLog[] =
    {
"=AND(1;0)",
"=AND(R[0]C[2]; R[0]C[3])",
"=AND(R[0]C[2]:R[1]C[2]; R[0]C[3]:R[1]C[3])",
"=AND(1<RC[4]; RC[4]<100)",
"=AND(2+2=4; 2+3=5)",
"=AND(TRUE; FALSE)",
"=AND(TRUE; TRUE)",
"=FALSE()",
"=IF(RC[2]>RC[3];\"OK\";\"Add\")",
"=NOT(RC[2]!=2)",
"=NOT(FALSE)",
"=NOT(1+1=2)",
"=OR(R[0]C[2]:R[1]C[2])",
"=OR(RC[2]; RC[3])",
"=OR(R[0]C[2]:R[1]C[2]; R[0]C[3]:R[1]C[3])",
"=OR(1<RC[4]; RC[4]<100)",
"=TRUE( )",
NULL
};
//---------------------------------------------------------------------------
//Text and data functions
    char* g_ppchFormulasText[] =
    {
"=CHAR(65)",
"=CLEAN(CHAR(7)&\"text\"&CHAR(7))",
"=CODE(\"A\")",
"=CONCATENATE(RC[2]; RC[3])",
"=DOLLAR(1234,567; 2)",
"=EXACT(RC[2]; RC[3])",
"=FIND(\"m\";RC[2])",
"=FIXED(1234,567; 1)",
"=LEFT(RC[2]; 4)",
"=LEN(RC[2])",
"=LOWER(\"John Smith\")",
"=MID(\"Flued stream\"; 7; 20)",
"=PROPER(\"this is a TITLE \")",
"=REPLACE(\"1990\"; 3; 2; \"91\")",
"=REPT(RC[2]; 2)",
"=RIGHT(RC[2]; 4) ",
"=SEARCH(\"r\";\"Operators\";6)",
"=SUBSTITUTE(\"Quater 1, 1991\"; \"1\"; \"2\"; 1) ",
"=T(RC[2])",
"=TEXT(2,715; \"$0,00\")",
"=TRIM(\" Income   for    the   first    quater   \")",
"=UPPER(RC[2])",
"=VALUE(\"$1000\")",
NULL
};
//---------------------------------------------------------------------------
//Date and time functions
    char* g_ppchFormulasDateTime[] =
    {
"=DATE(91; 1; 1)",
"=DATEVALUE(\"8-22-55\")",
"=DAY(\"11-8-93\")",
"=DAYS360(\"1-1-93\"; \"2-3-93\")",
//"=EDATE(RC[2];1)",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
//"=EOMONTH(RC[2]; 1)",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=HOUR(\"3:30:30 PM\")",
"=MINUTE(\"4:48:00 PM\")",
"=MONTH(\"6-May\")",
//"=NETWORKDAYS(DATEVALUE(\"1-10-91\"); DATEVALUE(\"1-12-91\");R[0]C[2]:R[1]C[2])",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=NOW()",
"=SECOND(\"4:48:18 PM\")",
"=TIME(12; 0; 0)",
"=TIMEVALUE(\"2:24\")",
"=TODAY( )",
"=WEEKDAY(\"2-14-90\";2)",
//"=WORKDAY(DATEVALUE(\"03-01-91\"); 5;{33245; 33246})",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=YEAR(\"5-7-90\")",
//"=YEARFRAC(\"01-01-93\";\"06-30-93\";0)",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
NULL
};
//---------------------------------------------------------------------------
// Financial functions
    char* g_ppchFormulasFin[] =
    {
/* depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=ACCRINT(\"2-2-93\";\"3-8-93\";\"1-5-93\";0,1;1000;2;0)",
"=ACCRINTM(\"1-4-93\";\"1-6-93\";0,1;1000;3)",
"=AMORDEGRC(2400;34199;34334;300;1;0,15;1)",
"=AMORLINC(2400;34199;34334;300;1;0,15;1) ",
"=COUPDAYBS(\"2-1-93\";\"1-11-94\";2;1)",
"=COUPDAYS(\"2-1-93\";\"1-11-94\";2;1)",
"=COUPDAYSNC(\"2-1-93\";\"1-11-94\";2;1)",
"=COUPNCD(\"2-1-93\";\"1-11-94\";2;1)",
"=COUPNUM(\"2-1-93\";\"1-11-94\";2;1)",
"=COUPPCD(\"2-1-93\";\"1-11-94\";2;1)",
"=CUMIPMT(0,0075;360;125000;1;1;0)",
"=CUMPRINC(0,0075;360;125000;1;1;0)",
*/
"=DB(1000000;100000;6;1;7)",
"=DDB(2400;300;120;1;2)",
/* depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=DISC(\"1-2-93\";\"6-10-93\";97,975;100;2)",
"=DOLLARDE(1,02;16)",
"=DOLLARFR(1,125;16)",
"=DURATION(\"1-1-86\";\"1-1-94\";0,08;0,09;2;1)",
"=EFFECT(5,25%;4)",
*/
"=FV(0,5%; 12; -100; -1000; 1)",
//"=FVSCHEDULE(1;R[0]C[2]:R[1]C[2])",				  //depricated in MS Excel 2003 and later, but still supported in DirectXLS
//"=INTRATE(\"1-2-93\";\"1-5-93\";1000000;1014420;2)",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=IPMT(0,1; 3; 3; 800000;0;0)",
"=IRR(R[0]C[2]:R[1]C[2];-10%)",
//"=MDURATION(\"1-1-86\";\"1-1-94\";0,08;0,09;2;1)",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=MIRR(R[0]C[2]:R[1]C[2]; 10%; 14%)",
//"=NOMINAL(5,3543%;4)",				//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=NPER(12%/12; -100; -1000; 10000; 1)",
"=NPV(8%;R[0]C[2]:R[1]C[2])",
/*depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=ODDFPRICE(\"11-11-86\";\"3-1-99\";\"1-10-86\";\"3-1-87\";0,0785;0,0625;100;2;1)",
"=ODDFYIELD(\"2-1-91\";\"1-1-96\";\"1-1-91\";\"1-7-91\";0,0575;84,50;100;2;0)",
"=ODDLPRICE(\"7-2-87\";\"1-6-87\";\"1-10-86\";0,0375;0,0405;100;2;0)",
"=ODDLYIELD(\"2-4-87\";\"1-6-87\";\"2-12-86\";0,0375;99,875;100;2;0)",
*/
"=PMT(8%/12; 10; 10000; 0; 1)",
"=PPMT(10%/12; 1; 24; 2000;0)",
/*depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=PRICE(\"1-2-91\";\"1-11-99\";0,0575;0,065;100;2;0)",
"=PRICEDISC(\"1-2-93\";\"1-3-93\";0,0525;100;2)",
"=PRICEMAT(\"1-2-93\";\"1-4-93\";\"11-11-92\";0,061;0,061;0)",
*/
"=PV(0,08/12; 12*20; 500;0; 0)",
"=RATE(48; -200; 8000;0;0;0,1)",
//"=RECEIVED(\"1-2-93\";\"1-5-93\";1000000;0,0575;2)",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=SLN(30000; 7500; 10)",
"=SYD(30000;7500;10;10) ",
/*depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=TBILLEQ(\"3-3-93\";\"1-6-93\";0,0914)",
"=TBILLPRICE(\"3-3-93\";\"1-6-93\";0,09)",
"=TBILLYIELD(\"3-3-93\";\"1-6-93\";98,45) ",
*/
"=VDB(2400; 300; 10; 0; 0,875; 1,5;FALSE)",
"=VDB(2400; 300; 10; 0; 0,875; 1,5;0)",
/*depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=XIRR({-10000;2750;4250;3250;2750};{\"1-1-92\";\"1-3-92\";\"3-10-92\";\"1-2-93\";\"1-4-93\"};0,1)",
"=XNPV(0,1;R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=YIELD(\"1-2-91\";\"1-11-99\";0,0575;95,04287;100;2;0)",
"=YIELDDISC(\"1-2-93\";\"1-3-93\";99,795;100;2) ",
"=YIELDMAT(\"1-3-93\";\"1-3-93\";\"8-11-92\";0,0625;100,0123;0) ",
*/
NULL
};
//---------------------------------------------------------------------------
// Statistical functions
    char* g_ppchFormulasStat[] =
    {
"=AVEDEV(R[0]C[2]:R[1]C[2])",
"=AVERAGE(R[0]C[2]:R[1]C[2])",
"=AVERAGEA(R[0]C[2]:R[1]C[2])",
"=BETADIST(2;8;10;1;3)",
"=BETAINV(0,685470581;8;10;1;3) ",
"=BINOMDIST(6;10;0,5;FALSE) ",
"=CHIDIST(18,307;10)",
"=CHIINV(0,05;10)",
"=CHITEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=CHITEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=CONFIDENCE(0,05;2,5;50) ",
"=CORREL(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=COUNT(R[0]C[2]:R[1]C[2])",
"=COUNTA(R[0]C[2]:R[1]C[2])",
"=COVAR(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=CRITBINOM(6;0,5;0,75) ",
"=DEVSQ(R[0]C[2]:R[1]C[2])",
"=EXPONDIST(0,2;10;TRUE) ",
"=FDIST(15,20675;6;4)",
"=FINV(0,01;6;4) ",
"=FISHER(0,75)",
"=FISHERINV(0,972955)",
"=FORECAST(30;R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=FREQUENCY(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=FTEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=GAMMADIST(10;9;2;FALSE) ",
"=GAMMAINV(0,068094;9;2)",
"=GAMMALN(4) ",
"=GEOMEAN(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=GROWTH(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];R[0]C[4]:R[1]C[4];FALSE)",
"=GROWTH(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[4];R[0]C[5]:R[1]C[6];FALSE)",
"=HARMEAN(4)",
"=HYPGEOMDIST(1;4;8;20) ",
"=INTERCEPT(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=KURT(R[0]C[2]:R[1]C[3])",
"=LARGE(R[0]C[2]:R[0]C[4];3)",
"=LINEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];FALSE;FALSE)",
"=LINEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];FALSE;FALSE)",
"=LOGINV(0,039084; 3,5; 1,2) ",
"=LOGNORMDIST(4;3,5;1,2)",
"=MAX(R[0]C[2]:R[1]C[2])",
"=MAXA(R[0]C[2]:R[1]C[2])",
"=MEDIAN(R[0]C[2]:R[1]C[2])",
"=MIN(R[0]C[2]:R[1]C[2])",
"=MINA(R[0]C[2]:R[1]C[2])",
"=MODE(R[0]C[2]:R[1]C[2])",
"=NEGBINOMDIST(10;5;0,25)",
"=NORMDIST(42;40;1,5;TRUE)",
"=NORMINV(0,908789;40;1,5)",
"=NORMSDIST(1,333333)",
"=NORMSINV(0,908789)",
"=PEARSON(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=PERCENTILE(R[0]C[2]:R[1]C[2];0,3)",
"=PERCENTRANK(R[0]C[2]:R[1]C[2];2;3)",
"=PERMUT(100;3) ",
"=POISSON(2;5;FALSE)",
"=PROB(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];1;3)",
"=QUARTILE(R[0]C[2]:R[1]C[2];1)",
"=RANK(R[0]C[2];R[0]C[3]:R[1]C[3];1)",
"=RSQ(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=SKEW(3)",
"=SLOPE(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=SMALL(R[0]C[2]:R[1]C[2];1)",
"=STANDARDIZE(42;40;1,5)",
"=STDEV(R[0]C[2]:R[1]C[2])",
"=STDEV(R[0]C[2]:R[1]C[3])",
"=STDEVA(R[0]C[2]:R[1]C[2])",
"=STDEVA(R[0]C[2]:R[1]C[3])",
"=STDEVP(R[0]C[2]:R[1]C[2])",
"=STDEVP(R[0]C[2]:R[1]C[3])",
"=STDEVPA(R[0]C[2]:R[1]C[2])",
"=STDEVPA(R[0]C[2]:R[1]C[3])",
"=STEYX(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=TDIST(1,96;60;2) ",
"=TINV(0,054645;60)",
"=TINV(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];R[0]C[4]:R[1]C[4];TRUE)",
"=TRIMMEAN(R[0]C[2]:R[1]C[2];0,2)",
"=TTEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];2;1)",
"=VAR(R[0]C[2]:R[1]C[2])",
"=VAR(R[0]C[2]:R[1]C[3])",
"=VARA(R[0]C[2]:R[1]C[2])",
"=VARA(R[0]C[2]:R[1]C[3])",
"=VARP(R[0]C[2]:R[1]C[2])",
"=VARP(R[0]C[2]:R[1]C[3])",
"=VARPA(R[0]C[2]:R[1]C[2])",
"=VARPA(R[0]C[2]:R[1]C[3])",
"=WEIBULL(105;20;100;TRUE)",
"=ZTEST(R[0]C[2]:R[1]C[2];4)",
NULL
};
//---------------------------------------------------------------------------
// Information functions
    char* g_ppchFormulasInf[] =
    {
"=CELL(\"row\";R[0]C[2]:R[1]C[3])",
"=ERROR.TYPE(R[0]C[2])",
"=INFO(\"release\")",
"=ISBLANK(R[0]C[2])",
"=ISERR(R[0]C[2])",
"=ISERROR(R[0]C[2])",
"=ISLOGICAL(R[0]C[2])",
"=ISNA(R[0]C[2])",
"=ISNONTEXT(R[0]C[2])",
"=ISNUMBER(R[0]C[2])",
"=ISREF(R[0]C[2])",
"=ISTEXT(R[0]C[2])",
//"=ISODD(R[0]C[2])",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
//"=ISEVEN(R[0]C[2])",//depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=N(R[0]C[2])",
"=NA( )",
"=TYPE(R[0]C[2]:R[1]C[3])",
NULL
};
//---------------------------------------------------------------------------
// Database and list management functions
    char* g_ppchFormulasBD[] =
    {
"=DCOUNT(R[4]C[2]:R[10]C[6];\"Age\";R[0]C[2]:R[2]C[2])",
"=DCOUNTA(R[3]C[2]:R[9]C[6];\"Income\";R[-1]C[2]:R[1]C[2])",
"=DMAX(R[2]C[2]:R[8]C[6];\"Income\";R[-2]C[2]:R[0]C[2])",
"=DMIN(R[1]C[2]:R[7]C[6];\"Income\";R[-3]C[2]:R[-1]C[2])",
"=DSUM(R[0]C[2]:R[6]C[6];\"Income\";R[-4]C[2]:R[-2]C[2])",
"=DPRODUCT(R[-1]C[2]:R[5]C[6];\"Income\";R[-5]C[2]:R[-3]C[2])",
"=DAVERAGE(R[-2]C[2]:R[4]C[6];\"Income\";R[-6]C[2]:R[-4]C[2])",
"=DSTDEV(R[-3]C[2]:R[3]C[6];\"Income\";R[-7]C[2]:R[-5]C[2])",
"=DSTDEVP(R[-4]C[2]:R[2]C[6];\"Income\";R[-8]C[2]:R[-6]C[2])",
"=DVAR(R[-5]C[2]:R[1]C[6];\"Income\";R[-9]C[2]:R[-7]C[2])",
"=DVARP(R[-6]C[2]:R[0]C[6];\"Income\";R[-10]C[2]:R[-8]C[2])",
"=DGET(R[-7]C[2]:R[-1]C[6];\"Income\";R[-11]C[2]:R[-9]C[2])",
NULL
};
//---------------------------------------------------------------------------
// Lookup and reference functions
    char* g_ppchFormulasSsylka[] =
    {
"=ADDRESS(2;3;1;FALSE;\"[Book1]Sheet1\")",
"=AREAS(R[0]C[2]:R[1]C[3])",
"=CHOOSE(RC[2];RC[3];RC[4])",
"=COLUMN(R[0]C[2]:R[1]C[3])",
"=COLUMNS(R[0]C[2]:R[1]C[3])",
"=COLUMNS({1;2;3:4;5;6})",
"=HLOOKUP(RC[2];R[0]C[2]:R[1]C[3];2;RC[4])",
"=HYPERLINK(RC[2];RC[3])",
"=INDEX(R[0]C[2]:R[1]C[3];1;2)",
"=INDEX({1;2:3;4};0;2) ",			// returns an array because row == 0
"=INDEX(R[0]C[2]:R[1]C[3];1;2;1)",  // returns a  ref
"=INDIRECT(\"$C$11\";TRUE)",
"=LOOKUP(RC[2];R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])", // vector
"=LOOKUP(RC[2];R[0]C[2]:R[1]C[3])", // array
"=MATCH(RC[2];R[0]C[2]:R[1]C[2];1)",
"=OFFSET(R[0]C[2];2;3;1;1)", // returns a ref
"=ROW(R[0]C[2]:R[1]C[3])",
"=ROWS(R[0]C[2]:R[1]C[3])",
"=VLOOKUP(RC[2];R[0]C[2]:R[1]C[3];1;TRUE)",
NULL
};
//---------------------------------------------------------------------------
// Engineering  funtions
    char* g_ppchFormulasInjener[] =
    {
/*depricated in MS Excel 2003 and later, but still supported in DirectXLS
"=BESSELI(RC[2];RC[3])",
"=BESSELJ(RC[2];RC[3])",
"=BESSELK(RC[2];RC[3])",
"=BESSELY(RC[2];RC[3])",
"=BIN2DEC(RC[2])",
"=BIN2HEX(RC[2];RC[3])",
"=BIN2OCT(RC[2];RC[3])",
"=COMPLEX(RC[2];RC[3];\"j\")",
"=CONVERT(RC[2];\"g\";\"g\")",
"=DEC2BIN(RC[2];RC[3])",
"=DEC2HEX(RC[2];RC[3])",
"=DEC2OCT(RC[2];RC[3])",
"=DELTA(RC[2];RC[3])",
"=ERF(RC[2];RC[3])",
"=ERFC(RC[2])",
"=GESTEP(RC[2];RC[3])",
"=HEX2BIN(RC[2];RC[3])",
"=HEX2DEC(RC[2])",
"=HEX2OCT(RC[2];RC[3])",
"=IMABS(RC[2])",
"=IMAGINARY(RC[2])",
"=IMARGUMENT(RC[2])",
"=IMCONJUGATE(RC[2])",
"=IMCOS(RC[2])",
"=IMDIV(RC[2];RC[3])",
"=IMEXP(RC[2])",
"=IMLN(RC[2])",
"=IMLOG10(RC[2])",
"=IMLOG2(RC[2])",
"=IMPOWER(RC[2];RC[3])",
"=IMPRODUCT(R[0]C[2]:R[1]C[3])",
"=IMREAL(RC[2])",
"=IMSIN(RC[2])",
"=IMSQRT(RC[2])",
"=IMSUB(RC[2];RC[3])",
"=IMSUM(R[0]C[2]:R[1]C[3])",
"=IMSUM(R[0]C[2]:R[1]C[3];R[0]C[4]:R[1]C[5];R[0]C[6]:R[1]C[7])",
"=OCT2BIN(RC[2];RC[3])",
"=OCT2DEC(RC[2])",
"=OCT2HEX(RC[2];RC[3])",
*/
NULL
};
//---------------------------------------------------------------------------
// Array Functions
    char* g_ppchFormulasArray[] =
    {
"=TINV(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3];R[0]C[4]:R[1]C[4];TRUE)",
"=FREQUENCY(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[3])",
"=GROWTH(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[4];R[0]C[5]:R[1]C[6];FALSE)",
"=LINEST(R[0]C[2]:R[1]C[2];R[0]C[3]:R[1]C[4];FALSE;FALSE)",
"=COLUMN(R[0]C[2]:R[1]C[3])",
"=INDEX({1;2:3;4};0;2) ",					// returns an array because row == 0
"=INDEX({\"a\";\"b\":\"c\";\"d\"};0;2) ",	// returns an array because row == 0
"=INDEX({\"a)aa\";\"bb)b)b)b\":\"c)c)\";\"d)\"};0;2) ", // returns an array because row == 0
"=INDEX({\"a'aa\";\"bb'b'b'b\":\"c'c'\";\"d'\"};0;2) ", // returns an array because row == 0
"=ROW(R[0]C[2]:R[1]C[2])",
"=TRANSPOSE(R[0]C[2]:R[1]C[2])",
NULL
};
//---------------------------------------------------------------------------
// Miscel
    char* g_ppchFormulasMiscel[] =
    {
"=SUM(OFFSET(R[0]C[2];1;1;3;3))",
NULL
};
//---------------------------------------------------------------------------
// Formulas
    char* g_ppchFormulasFormulas[] =
    {
"=C2",
"=C2+D2",
"=C2*D2",
"=C2+D2+E2",
"=C2+D2*E2",
"=(C2)",
"=(C2+D2)",
"=C2+(D2)",
"=C2+(D2+E2)",
"=C2+(D2+E2+F2)+G2",
"=C2*(D2+E2+F2)+G2",
"=C2+(D2+E2+F2)*G2",
"=C2+(D2+E2/F2)*G2",
"=C2+(D2+E2/F2)*G2",
"=C2+((D2+E2)/F2)*G2",
"=(D2+E2)/F2",
"=((D2+E2)/F2)*G2+C2",
"=(C2+D2)/100",
"=\x22\128tr\x22",
"=FALSE()",
"=\x22(()))'''\x22",
"=SUM(C2)",
"=SUM(C2;D2)",
"=SUM(C2;D2;E2)",
"=SUMIF(C2;\x22\x31\x22;D2)",
"=SUMIF(C2:C3;\x22\x32\x22;D2:D3)",
"=SUM(C2:C3)",
"=\x22www\x22&\x22www\x22",
"=TEXT(G6;\x22 0 000\x22)",
"=SUMIF(C2;E2;D2)",
NULL
};
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Ariph( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasAriph[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasAriph[nFormulaOrdinal];
		TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Ariph( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Ariph( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Log( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasLog[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasLog[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Log( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Log( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Text( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasText[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasText[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Text( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Text( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_DateTime( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasDateTime[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasDateTime[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_DateTime( int nFormulaOrdinal)
{
    std::string sText = GetFormula_DateTime( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Fin( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasFin[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasFin[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Fin( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Fin( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Stat( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasStat[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasStat[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Stat( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Stat( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Inf( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasInf[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasInf[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Inf( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Inf( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_BD( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasBD[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasBD[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_BD( int nFormulaOrdinal)
{
    std::string sText = GetFormula_BD( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Ssylka( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasSsylka[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasSsylka[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Ssylka( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Ssylka( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Injener( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasInjener[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasInjener[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Injener( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Injener( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Array( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasArray[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasArray[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Array( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Array( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Miscel( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasMiscel[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasMiscel[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Miscel( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Miscel( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormula_Formulas( int nFormulaOrdinal)
{
    try
    {
        if( !g_ppchFormulasFormulas[nFormulaOrdinal])
        {
            return "";
        }
        std::string sName = g_ppchFormulasFormulas[nFormulaOrdinal];
        TrimRight( sName);
        return sName;
    }
    catch(...)
    {
        throw std::runtime_error( "Out of Func Formulas");
    }
}
//---------------------------------------------------------------------------
std::string CDemoLowLevel::GetFormulaText_Formulas( int nFormulaOrdinal)
{
    std::string sText = GetFormula_Formulas( nFormulaOrdinal);
    if( sText.empty())
    {
        return "";
    }
    int nPos = sText.find('(');
    if( nPos >= 0)
    {
        sText = sText.substr( 0, nPos);
    }
    return sText.substr( 1, sText.size() - 1);
}
//---------------------------------------------------------------------------
void CDemoLowLevel::TrimRight( std::string& str)
{
	for( unsigned int pos = str.size() - 1; pos < -1; pos--)
	{
		if( str[pos] != ' ')
		{
			str = str.substr( 0, pos + 1);
			return;
		}
	}
}
//---------------------------------------------------------------------------
std::string& CDemoLowLevel::Replace( std::string& str, char oldc, char newc)
{
	int pos=-1;
	while ((pos=(int)str.find(oldc,pos+1))!=-1)
	{
		str.operator[](pos)=newc;
	}
    return str;
}
//---------------------------------------------------------------------------
